package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.grade.domain.ClassGradeInterface;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.SchoolProjectAddBo;
import com.zhongzheng.modules.user.bo.SchoolProjectQueryBo;
import com.zhongzheng.modules.user.bo.SchoolProjectEditBo;
import com.zhongzheng.modules.user.domain.SchoolProject;
import com.zhongzheng.modules.user.mapper.SchoolProjectMapper;
import com.zhongzheng.modules.user.vo.SchoolProjectVo;
import com.zhongzheng.modules.user.service.ISchoolProjectService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 院校绑定项目Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-09
 */
@Service
public class SchoolProjectServiceImpl extends ServiceImpl<SchoolProjectMapper, SchoolProject> implements ISchoolProjectService {

    @Override
    public SchoolProjectVo queryById(Long id){
        SchoolProject db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, SchoolProjectVo.class);
    }

    @Override
    public List<SchoolProjectVo> queryList(SchoolProjectQueryBo bo) {
        LambdaQueryWrapper<SchoolProject> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getProjectId() != null, SchoolProject::getProjectId, bo.getProjectId());
        lqw.eq(bo.getSchoolId() != null, SchoolProject::getSchoolId, bo.getSchoolId());
        lqw.orderByDesc(SchoolProject::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<SchoolProjectVo> entity2Vo(Collection<SchoolProject> collection) {
        List<SchoolProjectVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, SchoolProjectVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<SchoolProject> page = (Page<SchoolProject>)collection;
            Page<SchoolProjectVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(SchoolProjectAddBo bo) {
        SchoolProject add = BeanUtil.toBean(bo, SchoolProject.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(SchoolProjectEditBo bo) {
        SchoolProject update = BeanUtil.toBean(bo, SchoolProject.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(SchoolProject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
